--- old/usr/src/uts/common/io/scsi/adapters/mpt_sas3/mptsas3.c	2014-06-12 17:42:15.393924923 +0100
+++ new/usr/src/uts/common/io/scsi/adapters/mpt_sas3/mptsas3.c	2014-06-12 17:42:15.405774308 +0100
@@ -5303,17 +6025,17 @@
 }
 
 static void
-mptsas_doneq_thread(mptsas_doneq_thread_arg_t *arg)
+mptsas_doneq_thread(mptsas_thread_arg_t *arg)
 {
 	mptsas_t			*mpt = arg->mpt;
-	uint64_t			t = arg->t;
+	uint32_t			t = arg->t;
 	mptsas_cmd_t			*cmd;
 	struct scsi_pkt			*pkt;
 	mptsas_doneq_thread_list_t	*item = &mpt->m_doneq_thread_id[t];
 
 	mutex_enter(&item->mutex);
 	while (item->flag & MPTSAS_DONEQ_THREAD_ACTIVE) {
-		if (!item->doneq) {
+		if (!item->dlist.dl_q) {
 			cv_wait(&item->cv, &item->mutex);
 		}
 		pkt = NULL;
@@ -5328,10 +6050,10 @@
 		mutex_enter(&item->mutex);
 	}
 	mutex_exit(&item->mutex);
-	mutex_enter(&mpt->m_doneq_mutex);
+	mutex_enter(&mpt->m_qthread_mutex);
 	mpt->m_doneq_thread_n--;
-	cv_broadcast(&mpt->m_doneq_thread_cv);
-	mutex_exit(&mpt->m_doneq_mutex);
+	cv_broadcast(&mpt->m_qthread_cv);
+	mutex_exit(&mpt->m_qthread_mutex);
 }
 
 
@@ -5342,12 +6064,17 @@
 mptsas_intr(caddr_t arg1, caddr_t arg2)
 {
 	mptsas_t			*mpt = (void *)arg1;
+	mptsas_reply_pqueue_t		*rpqp;
+	int				reply_q = (int)(uintptr_t)arg2;
 	pMpi2ReplyDescriptorsUnion_t	reply_desc_union;
-	uchar_t				did_reply = FALSE;
+	int				found = 0, i, rpqidx;
+	size_t				dma_sync_len;
+	off_t				dma_sync_offset;
+	uint32_t			istat;
 
-	NDBG1(("mptsas_intr: arg1 0x%p arg2 0x%p", (void *)arg1, (void *)arg2));
+	NDBG18(("mptsas_intr: arg1 0x%p reply_q 0x%d", (void *)arg1, reply_q));
 
-	mutex_enter(&mpt->m_mutex);
+	rpqp = &mpt->m_rep_post_queues[reply_q];
 
 	/*
 	 * If interrupts are shared by two channels then check whether this
@@ -5356,8 +6083,23 @@
 	 */
 	if ((mpt->m_options & MPTSAS_OPT_PM) &&
 	    (mpt->m_power_level != PM_LEVEL_D0)) {
-		mutex_exit(&mpt->m_mutex);
+		mpt->m_unclaimed_pm_interrupt_count++;
+		return (DDI_INTR_UNCLAIMED);
+	}
+
+	istat = MPTSAS_GET_ISTAT(mpt);
+	if (!(istat & MPI2_HIS_REPLY_DESCRIPTOR_INTERRUPT)) {
+		NDBG18(("Interrupt bit not set, istat 0x%x", istat));
+		mpt->m_unclaimed_no_interrupt_count++;
+		/*
+		 * Really need a good definition of when this is valid.
+		 * It appears not to be if you have multiple reply post
+		 * queues, there may be a better way - need LSI info.
+		 * For now just count them.
+		 */
+#if 0
 		return (DDI_INTR_UNCLAIMED);
+#endif
 	}
 
 	/*
@@ -5367,64 +6109,114 @@
 	 * return with interrupt unclaimed.
 	 */
 	if (mpt->m_polled_intr) {
-		mutex_exit(&mpt->m_mutex);
-		mptsas_log(mpt, CE_WARN, "mpt_sas: Unclaimed interrupt");
+		mptsas_log(mpt, CE_WARN,
+		    "Unclaimed interrupt, rpq %d (Polling), istat 0x%x",
+		    reply_q, istat);
+		mpt->m_unclaimed_polled_interrupt_count++;
 		return (DDI_INTR_UNCLAIMED);
 	}
 
 	/*
-	 * Read the istat register.
+	 * At the moment this is the only place the mutex is grabbed.
+	 * So it should never fail!
 	 */
-	if ((INTPENDING(mpt)) != 0) {
-		/*
-		 * read fifo until empty.
-		 */
+	if (mutex_tryenter(&rpqp->rpq_mutex) == 0) {
+		mutex_enter(&rpqp->rpq_mutex);
+		rpqp->rpq_intr_mutexbusy++;
+	}
+
+	dma_sync_len = mpt->m_post_queue_depth * 8;
+	dma_sync_offset = dma_sync_len * reply_q;
+	(void) ddi_dma_sync(mpt->m_dma_post_queue_hdl,
+	    dma_sync_offset, dma_sync_len, DDI_DMA_SYNC_FORCPU);
+
+	/*
+	 * Go around the reply queue and process each descriptor until
+	 * we get to the next unused one.
+	 * It seems to be an occupational hazard that we get interrupts
+	 * with nothing to do. These are counted below.
+	 */
+	rpqidx = rpqp->rpq_index;
 #ifndef __lock_lint
-		_NOTE(CONSTCOND)
+	_NOTE(CONSTCOND)
 #endif
-		while (TRUE) {
-			(void) ddi_dma_sync(mpt->m_dma_post_queue_hdl, 0, 0,
-			    DDI_DMA_SYNC_FORCPU);
-			reply_desc_union = (pMpi2ReplyDescriptorsUnion_t)
-			    MPTSAS_GET_NEXT_REPLY(mpt, mpt->m_post_index);
+	while (TRUE) {
+		reply_desc_union = (pMpi2ReplyDescriptorsUnion_t)
+		    MPTSAS_GET_NEXT_REPLY(rpqp, rpqidx);
 
-			if (ddi_get32(mpt->m_acc_post_queue_hdl,
-			    &reply_desc_union->Words.Low) == 0xFFFFFFFF ||
-			    ddi_get32(mpt->m_acc_post_queue_hdl,
-			    &reply_desc_union->Words.High) == 0xFFFFFFFF) {
-				break;
-			}
+		if (ddi_get32(mpt->m_acc_post_queue_hdl,
+		    &reply_desc_union->Words.Low) == 0xFFFFFFFF ||
+		    ddi_get32(mpt->m_acc_post_queue_hdl,
+		    &reply_desc_union->Words.High) == 0xFFFFFFFF) {
+			break;
+		}
 
-			/*
-			 * The reply is valid, process it according to its
-			 * type.  Also, set a flag for updating the reply index
-			 * after they've all been processed.
-			 */
-			did_reply = TRUE;
+		found++;
 
-			mptsas_process_intr(mpt, reply_desc_union);
+		ASSERT(ddi_get8(mpt->m_acc_post_queue_hdl,
+		    &reply_desc_union->Default.MSIxIndex) == reply_q);
 
-			/*
-			 * Increment post index and roll over if needed.
-			 */
-			if (++mpt->m_post_index == mpt->m_post_queue_depth) {
-				mpt->m_post_index = 0;
-			}
-		}
+		/*
+		 * Process it according to its type.
+		 */
+		mptsas_process_intr(mpt, rpqp, reply_desc_union);
 
 		/*
-		 * Update the global reply index if at least one reply was
-		 * processed.
+		 * Clear the reply descriptor for re-use.
 		 */
-		if (did_reply) {
-			ddi_put32(mpt->m_datap,
-			    &mpt->m_reg->ReplyPostHostIndex, mpt->m_post_index);
+		ddi_put64(mpt->m_acc_post_queue_hdl,
+		    &((uint64_t *)(void *)rpqp->rpq_queue)[rpqidx],
+		    0xFFFFFFFFFFFFFFFF);
+
+		/*
+		 * Increment post index and roll over if needed.
+		 */
+		if (++rpqidx == mpt->m_post_queue_depth) {
+			rpqidx = 0;
 		}
-	} else {
-		mutex_exit(&mpt->m_mutex);
+	}
+
+	if (found == 0) {
+		rpqp->rpq_intr_unclaimed++;
+		mutex_exit(&rpqp->rpq_mutex);
+		mpt->m_unclaimed_nocmd_interrupt_count++;
 		return (DDI_INTR_UNCLAIMED);
 	}
-	NDBG1(("mptsas_intr complete"));
+	rpqp->rpq_index = rpqidx;
+
+	rpqp->rpq_intr_count++;
+	NDBG18(("mptsas_intr complete(%d), did %d loops", reply_q, found));
+
+	(void) ddi_dma_sync(mpt->m_dma_post_queue_hdl,
+	    dma_sync_offset, dma_sync_len, DDI_DMA_SYNC_FORDEV);
+
+	mpt->m_interrupt_count++;
+
+	/*
+	 * Update the reply index if at least one reply was processed.
+	 * For more than 8 reply queues on SAS3 controllers we have to do
+	 * things a little different. See Chapter 20 in the MPI 2.5 spec.
+	 */
+	if (mpt->m_post_reply_qcount > 8) {
+		/*
+		 * The offsets from the base are multiples of 0x10.
+		 * We are indexing into 32 bit quantities so calculate
+		 * the index for that.
+		 */
+		i = (reply_q&~0x7) >> 1;
+		ddi_put32(mpt->m_datap,
+		    &mpt->m_reg->SuppReplyPostHostIndex[i],
+		    rpqp->rpq_index |
+		    ((reply_q&0x7)<<MPI2_RPHI_MSIX_INDEX_SHIFT));
+		(void) ddi_get32(mpt->m_datap,
+		    &mpt->m_reg->SuppReplyPostHostIndex[i]);
+	} else {
+		ddi_put32(mpt->m_datap,
+		    &mpt->m_reg->ReplyPostHostIndex,
+		    rpqp->rpq_index | (reply_q<<MPI2_RPHI_MSIX_INDEX_SHIFT));
+		(void) ddi_get32(mpt->m_datap,
+		    &mpt->m_reg->ReplyPostHostIndex);
+	}
 
 	/*
 	 * If no helper threads are created, process the doneq in ISR. If
@@ -5433,32 +6225,65 @@
 	 * load is heavy, then we deliver the IO completions to the helpers.
 	 * This measurement has some limitations, although it is simple and
 	 * straightforward and works well for most of the cases at present.
+	 * To always use the threads set mptsas_doneq_length_threshold_prop
+	 * to zero in the mpt_sas3.conf file.
+	 *
+	 * Check the current reply queue done queue.
 	 */
-	if (!mpt->m_doneq_thread_n ||
-	    (mpt->m_doneq_len <= mpt->m_doneq_length_threshold)) {
-		mptsas_doneq_empty(mpt);
-	} else {
-		mptsas_deliver_doneq_thread(mpt);
+	if (rpqp->rpq_dlist.dl_len) {
+		if (!mpt->m_doneq_thread_n ||
+		    (rpqp->rpq_dlist.dl_len <= mpt->m_doneq_length_threshold)) {
+			mptsas_rpdoneq_empty(rpqp);
+		} else {
+			mptsas_deliver_doneq_thread(mpt, &rpqp->rpq_dlist);
+		}
+	}
+
+	mutex_exit(&rpqp->rpq_mutex);
+
+	/*
+	 * Check the main done queue. If we find something
+	 * grab the mutex and check again before processing.
+	 */
+	if (mpt->m_dlist.dl_len) {
+		mutex_enter(&mpt->m_mutex);
+		if (mpt->m_dlist.dl_len) {
+			if (!mpt->m_doneq_thread_n ||
+			    (mpt->m_dlist.dl_len <=
+			    mpt->m_doneq_length_threshold)) {
+				mptsas_doneq_empty(mpt);
+			} else {
+				mptsas_deliver_doneq_thread(mpt, &mpt->m_dlist);
+			}
+		}
+		mutex_exit(&mpt->m_mutex);
 	}
 
 	/*
 	 * If there are queued cmd, start them now.
 	 */
 	if (mpt->m_waitq != NULL) {
-		mptsas_restart_waitq(mpt);
+		mutex_enter(&mpt->m_mutex);
+		if (mpt->m_waitq != NULL && mpt->m_polled_intr == 0) {
+			mptsas_restart_waitq(mpt);
+		}
+		mutex_exit(&mpt->m_mutex);
 	}
-
-	mutex_exit(&mpt->m_mutex);
 	return (DDI_INTR_CLAIMED);
 }
 
 static void
-mptsas_process_intr(mptsas_t *mpt,
+mptsas_process_intr(mptsas_t *mpt, mptsas_reply_pqueue_t *rpqp,
     pMpi2ReplyDescriptorsUnion_t reply_desc_union)
 {
 	uint8_t	reply_type;
 
-	ASSERT(mutex_owned(&mpt->m_mutex));
+	/*
+	 * Should get here with the reply queue mutex held, but not
+	 * the main mpt mutex. Want to avoid grabbing that during
+	 * normal operations if possible.
+	 */
+	ASSERT(mutex_owned(&rpqp->rpq_mutex));
 
 	/*
 	 * The reply is valid, process it according to its
@@ -5467,25 +6292,20 @@
 	 */
 	reply_type = ddi_get8(mpt->m_acc_post_queue_hdl,
 	    &reply_desc_union->Default.ReplyFlags);
+	NDBG18(("mptsas_process_intr(rpq %d) reply_type 0x%x", rpqp->rpq_num,
+	    reply_type));
 	reply_type &= MPI2_RPY_DESCRIPT_FLAGS_TYPE_MASK;
-	if (reply_type == MPI2_RPY_DESCRIPT_FLAGS_SCSI_IO_SUCCESS) {
-		mptsas_handle_scsi_io_success(mpt, reply_desc_union);
+	if (reply_type == MPI2_RPY_DESCRIPT_FLAGS_SCSI_IO_SUCCESS ||
+	    reply_type == MPI25_RPY_DESCRIPT_FLAGS_FAST_PATH_SCSI_IO_SUCCESS) {
+		mptsas_handle_scsi_io_success(mpt, rpqp, reply_desc_union);
 	} else if (reply_type == MPI2_RPY_DESCRIPT_FLAGS_ADDRESS_REPLY) {
+		mutex_enter(&mpt->m_mutex);
 		mptsas_handle_address_reply(mpt, reply_desc_union);
+		mutex_exit(&mpt->m_mutex);
 	} else {
 		mptsas_log(mpt, CE_WARN, "?Bad reply type %x", reply_type);
 		ddi_fm_service_impact(mpt->m_dip, DDI_SERVICE_UNAFFECTED);
 	}
-
-	/*
-	 * Clear the reply descriptor for re-use and increment
-	 * index.
-	 */
-	ddi_put64(mpt->m_acc_post_queue_hdl,
-	    &((uint64_t *)(void *)mpt->m_post_queue)[mpt->m_post_index],
-	    0xFFFFFFFFFFFFFFFF);
-	(void) ddi_dma_sync(mpt->m_dma_post_queue_hdl, 0, 0,
-	    DDI_DMA_SYNC_FORDEV);
 }
 
 /*
@@ -5496,6 +6316,7 @@
 {
 	mptsas_target_t	*ptgt = cmd->cmd_tgt_addr;
 
+	mutex_enter(&ptgt->m_t_mutex);
 	if ((++cmd->cmd_qfull_retries > ptgt->m_qfull_retries) ||
 	    (ptgt->m_qfull_retries == 0)) {
 		/*
@@ -5513,13 +6334,13 @@
 			ptgt->m_t_throttle =
 			    max((ptgt->m_t_ncmds - 2), 0);
 		}
+		mutex_exit(&ptgt->m_t_mutex);
 
-		cmd->cmd_pkt_flags |= FLAG_HEAD;
 		cmd->cmd_flags &= ~(CFLAG_TRANFLAG);
-		cmd->cmd_flags |= CFLAG_RETRY;
 
-		(void) mptsas_accept_pkt(mpt, cmd);
+		mptsas_retry_pkt(mpt, cmd);
 
+		mutex_enter(&ptgt->m_t_mutex);
 		/*
 		 * when target gives queue full status with no commands
 		 * outstanding (m_t_ncmds == 0), throttle is set to 0
@@ -5542,6 +6363,7 @@
 			}
 		}
 	}
+	mutex_exit(&ptgt->m_t_mutex);
 }
 
 mptsas_phymask_t
@@ -5550,7 +6372,7 @@
 	mptsas_phymask_t	phy_mask = 0;
 	uint8_t			i = 0;
 
-	NDBG20(("mptsas%d physport_to_phymask enter", mpt->m_instance));
+	NDBG20(("mptsas3%d physport_to_phymask enter", mpt->m_instance));
 
 	ASSERT(mutex_owned(&mpt->m_mutex));
 
@@ -5569,7 +6391,7 @@
 			break;
 		}
 	}
-	NDBG20(("mptsas%d physport_to_phymask:physport :%x phymask :%x, ",
+	NDBG20(("mptsas3%d physport_to_phymask:physport :%x phymask :%x, ",
 	    mpt->m_instance, physport, phy_mask));
 	return (phy_mask);
 }
@@ -5623,7 +6445,7 @@
 	uint8_t		current_port;
 	int		i, j;
 
-	NDBG20(("mptsas%d update phymask ", mpt->m_instance));
+	NDBG20(("mptsas3%d update phymask ", mpt->m_instance));
 
 	ASSERT(mutex_owned(&mpt->m_mutex));
 
@@ -5669,7 +6491,7 @@
 		mutex_enter(&mpt->m_mutex);
 	}
 	kmem_free(phy_mask_name, MPTSAS_MAX_PHYS);
-	NDBG20(("mptsas%d update phymask return", mpt->m_instance));
+	NDBG20(("mptsas3%d update phymask return", mpt->m_instance));
 }
 
 /*
@@ -5689,7 +6511,7 @@
 	mptsas_t			*mpt;
 	dev_info_t			*parent = NULL;
 	mptsas_phymask_t		phymask = 0;
-	char				*phy_mask_name;
+	char				phy_mask_name[MPTSAS_MAX_PHYS];
 	uint8_t				flags = 0, physport = 0xff;
 	uint8_t				port_update = 0;
 	uint_t				event;
@@ -5700,9 +6522,7 @@
 	event = topo_node->event;
 	flags = topo_node->flags;
 
-	phy_mask_name = kmem_zalloc(MPTSAS_MAX_PHYS, KM_SLEEP);
-
-	NDBG20(("mptsas%d handle_dr enter", mpt->m_instance));
+	NDBG20(("mptsas3%d handle_dr enter", mpt->m_instance));
 
 	switch (event) {
 	case MPTSAS_DR_EVENT_RECONFIG_TARGET:
@@ -5744,12 +6564,26 @@
 
 	}
 	mutex_exit(&mpt->m_mutex);
+
 	while (topo_node) {
 		phymask = 0;
+		flags = topo_node->flags;
+		event = topo_node->event;
+		if (event == MPTSAS_DR_EVENT_REMOVE_HANDLE) {
+			goto handle_topo_change;
+		}
+		if ((event == MPTSAS_DR_EVENT_RECONFIG_TARGET) &&
+		    (flags == MPTSAS_TOPO_FLAG_RAID_PHYSDRV_ASSOCIATED)) {
+			/*
+			 * There is no any field in IR_CONFIG_CHANGE
+			 * event indicate physport/phynum, let's get
+			 * parent after SAS Device Page0 request.
+			 */
+			goto handle_topo_change;
+		}
+
 		if (parent == NULL) {
 			physport = topo_node->un.physport;
-			event = topo_node->event;
-			flags = topo_node->flags;
 			if (event & (MPTSAS_DR_EVENT_OFFLINE_TARGET |
 			    MPTSAS_DR_EVENT_OFFLINE_SMP)) {
 				/*
@@ -5758,25 +6592,11 @@
 				phymask = topo_node->un.phymask;
 				goto find_parent;
 			}
-			if (event & MPTSAS_TOPO_FLAG_REMOVE_HANDLE) {
-				goto handle_topo_change;
-			}
 			if (flags & MPTSAS_TOPO_FLAG_LUN_ASSOCIATED) {
 				phymask = topo_node->un.phymask;
 				goto find_parent;
 			}
 
-			if ((flags ==
-			    MPTSAS_TOPO_FLAG_RAID_PHYSDRV_ASSOCIATED) &&
-			    (event == MPTSAS_DR_EVENT_RECONFIG_TARGET)) {
-				/*
-				 * There is no any field in IR_CONFIG_CHANGE
-				 * event indicate physport/phynum, let's get
-				 * parent after SAS Device Page0 request.
-				 */
-				goto handle_topo_change;
-			}
-
 			mutex_enter(&mpt->m_mutex);
 			if (flags == MPTSAS_TOPO_FLAG_DIRECT_ATTACHED_DEVICE) {
 				/*
@@ -5792,8 +6612,7 @@
 			 * Translate physport to phymask so that we can search
 			 * parent dip.
 			 */
-			phymask = mptsas_physport_to_phymask(mpt,
-			    physport);
+			phymask = mptsas_physport_to_phymask(mpt, physport);
 			mutex_exit(&mpt->m_mutex);
 
 find_parent:
@@ -5806,20 +6625,17 @@
 				(void) sprintf(phy_mask_name, "v0");
 			} else {
 				/*
-				 * phymask can bo 0 if the drive has been
+				 * phymask can be 0 if the drive has been
 				 * pulled by the time an add event is
 				 * processed.  If phymask is 0, just skip this
 				 * event and continue.
 				 */
 				if (phymask == 0) {
-					mutex_enter(&mpt->m_mutex);
 					save_node = topo_node;
 					topo_node = topo_node->next;
 					ASSERT(save_node);
 					kmem_free(save_node,
 					    sizeof (mptsas_topo_change_list_t));
-					mutex_exit(&mpt->m_mutex);
-
 					parent = NULL;
 					continue;
 				}
@@ -5829,43 +6645,137 @@
 			    phy_mask_name);
 			if (parent == NULL) {
 				mptsas_log(mpt, CE_WARN, "Failed to find an "
-				    "iport, should not happen!");
-				goto out;
+				    "iport for \"%s\", should not happen!",
+				    phy_mask_name);
+				save_node = topo_node;
+				topo_node = topo_node->next;
+				ASSERT(save_node);
+				kmem_free(save_node,
+				    sizeof (mptsas_topo_change_list_t));
+				continue;
 			}
 
 		}
-		ASSERT(parent);
-handle_topo_change:
+		ASSERT(parent);
+handle_topo_change:
+
+		mutex_enter(&mpt->m_mutex);
+		/*
+		 * If HBA is being reset, don't perform operations depending
+		 * on the IOC. We must free the topo list, however.
+		 */
+		if (!mpt->m_in_reset)
+			mptsas_handle_topo_change(topo_node, parent);
+		else
+			NDBG20(("skipping topo change received during reset"));
+		mutex_exit(&mpt->m_mutex);
+		save_node = topo_node;
+		topo_node = topo_node->next;
+		ASSERT(save_node);
+		kmem_free(save_node, sizeof (mptsas_topo_change_list_t));
+
+		if ((flags == MPTSAS_TOPO_FLAG_DIRECT_ATTACHED_DEVICE) ||
+		    (flags == MPTSAS_TOPO_FLAG_RAID_PHYSDRV_ASSOCIATED) ||
+		    (flags == MPTSAS_TOPO_FLAG_RAID_ASSOCIATED)) {
+			/*
+			 * If direct attached device associated, make sure
+			 * reset the parent before start the next one. But
+			 * all devices associated with expander shares the
+			 * parent.  Also, reset parent if this is for RAID.
+			 */
+			parent = NULL;
+		}
+	}
+}
+
+static void
+mptsas_offline_target(mptsas_t *mpt, mptsas_target_t *ptgt,
+    uint8_t topo_flags, dev_info_t *parent)
+{
+	uint64_t	sas_wwn = 0;
+	uint8_t		phy;
+	char		wwn_str[MPTSAS_WWN_STRLEN];
+	uint16_t	devhdl;
+	int		circ = 0, circ1 = 0;
+	int		rval = 0;
+
+	sas_wwn = ptgt->m_addr.mta_wwn;
+	phy = ptgt->m_phynum;
+	devhdl = ptgt->m_devhdl;
+
+	if (sas_wwn) {
+		(void) sprintf(wwn_str, "w%016"PRIx64, sas_wwn);
+	} else {
+		(void) sprintf(wwn_str, "p%x", phy);
+	}
+
+	/*
+	 * Abort all outstanding command on the device
+	 */
+	rval = mptsas_do_scsi_reset(mpt, devhdl);
+	if (rval) {
+		NDBG20(("mptsas3%d: mptsas_offline_target: reset target "
+		    "before offline devhdl:%x, phymask:%x, rval:%x",
+		    mpt->m_instance, ptgt->m_devhdl,
+		    ptgt->m_addr.mta_phymask, rval));
+	}
+
+	mutex_exit(&mpt->m_mutex);
+
+	ndi_devi_enter(scsi_vhci_dip, &circ);
+	ndi_devi_enter(parent, &circ1);
+	rval = mptsas_offline_targetdev(parent, wwn_str);
+	ndi_devi_exit(parent, circ1);
+	ndi_devi_exit(scsi_vhci_dip, circ);
+	NDBG20(("mptsas3%d: mptsas_offline_target %s devhdl:%x, "
+	    "phymask:%x, rval:%x", mpt->m_instance, wwn_str,
+	    ptgt->m_devhdl, ptgt->m_addr.mta_phymask, rval));
+
+	/*
+	 * Clear parent's props for SMHBA support
+	 */
+	if (topo_flags == MPTSAS_TOPO_FLAG_DIRECT_ATTACHED_DEVICE) {
+		if (ddi_prop_update_string(DDI_DEV_T_NONE, parent,
+		    SCSI_ADDR_PROP_ATTACHED_PORT, "") !=
+		    DDI_PROP_SUCCESS) {
+			(void) ddi_prop_remove(DDI_DEV_T_NONE, parent,
+			    SCSI_ADDR_PROP_ATTACHED_PORT);
+			mptsas_log(mpt, CE_WARN, "mptsas attached port "
+			    "prop update failed");
+		}
+		if (ddi_prop_update_int(DDI_DEV_T_NONE, parent,
+		    MPTSAS_NUM_PHYS, 0) != DDI_PROP_SUCCESS) {
+			(void) ddi_prop_remove(DDI_DEV_T_NONE, parent,
+			    MPTSAS_NUM_PHYS);
+			mptsas_log(mpt, CE_WARN, "mptsas num phys "
+			    "prop update failed");
+		}
+		if (ddi_prop_update_int(DDI_DEV_T_NONE, parent,
+		    MPTSAS_VIRTUAL_PORT, 1) != DDI_PROP_SUCCESS) {
+			(void) ddi_prop_remove(DDI_DEV_T_NONE, parent,
+			    MPTSAS_VIRTUAL_PORT);
+			mptsas_log(mpt, CE_WARN, "mptsas virtual port "
+			    "prop update failed");
+		}
+	}
 
-		mutex_enter(&mpt->m_mutex);
+	mutex_enter(&mpt->m_mutex);
+	ptgt->m_led_status = 0;
+	(void) mptsas_flush_led_status(mpt, ptgt);
+	if (rval == DDI_SUCCESS) {
+		mutex_destroy(&ptgt->m_t_mutex);
+		refhash_remove(mpt->m_targets, ptgt);
+		ptgt = NULL;
+	} else {
 		/*
-		 * If HBA is being reset, don't perform operations depending
-		 * on the IOC. We must free the topo list, however.
-		 */
-		if (!mpt->m_in_reset)
-			mptsas_handle_topo_change(topo_node, parent);
-		else
-			NDBG20(("skipping topo change received during reset"));
-		save_node = topo_node;
-		topo_node = topo_node->next;
-		ASSERT(save_node);
-		kmem_free(save_node, sizeof (mptsas_topo_change_list_t));
-		mutex_exit(&mpt->m_mutex);
-
-		if ((flags == MPTSAS_TOPO_FLAG_DIRECT_ATTACHED_DEVICE) ||
-		    (flags == MPTSAS_TOPO_FLAG_RAID_PHYSDRV_ASSOCIATED) ||
-		    (flags == MPTSAS_TOPO_FLAG_RAID_ASSOCIATED)) {
-			/*
-			 * If direct attached device associated, make sure
-			 * reset the parent before start the next one. But
-			 * all devices associated with expander shares the
-			 * parent.  Also, reset parent if this is for RAID.
-			 */
-			parent = NULL;
-		}
+		 * clean DR_INTRANSITION flag to allow I/O down to
+		 * PHCI driver since failover finished.
+		 * Invalidate the devhdl
+		 */
+		ptgt->m_devhdl = MPTSAS_INVALID_DEVHDL;
+		ptgt->m_tgt_unconfigured = 0;
+		ptgt->m_dr_flag = MPTSAS_DR_INACTIVE;
 	}
-out:
-	kmem_free(phy_mask_name, MPTSAS_MAX_PHYS);
 }
 
 static void
@@ -5877,16 +6787,16 @@
 	mptsas_t	*mpt = (void *)topo_node->mpt;
 	uint16_t	devhdl;
 	uint16_t	attached_devhdl;
-	uint64_t	sas_wwn = 0;
 	int		rval = 0;
 	uint32_t	page_address;
-	uint8_t		phy, flags;
-	char		*addr = NULL;
+	uint8_t		flags;
 	dev_info_t	*lundip;
 	int		circ = 0, circ1 = 0;
 	char		attached_wwnstr[MPTSAS_WWN_STRLEN];
 
-	NDBG20(("mptsas%d handle_topo_change enter", mpt->m_instance));
+	NDBG20(("mptsas3%d handle_topo_change enter, devhdl 0x%x,"
+	    "event 0x%x, flags 0x%x", mpt->m_instance, topo_node->devhdl,
+	    topo_node->event, topo_node->flags));
 
 	ASSERT(mutex_owned(&mpt->m_mutex));
 
@@ -6046,7 +6956,7 @@
 		}
 		mutex_enter(&mpt->m_mutex);
 
-		NDBG20(("mptsas%d handle_topo_change to online devhdl:%x, "
+		NDBG20(("mptsas3%d handle_topo_change to online devhdl:%x, "
 		    "phymask:%x.", mpt->m_instance, ptgt->m_devhdl,
 		    ptgt->m_addr.mta_phymask));
 		break;
@@ -6059,16 +6969,6 @@
 		if (ptgt == NULL)
 			break;
 
-		sas_wwn = ptgt->m_addr.mta_wwn;
-		phy = ptgt->m_phynum;
-
-		addr = kmem_zalloc(SCSI_MAXNAMELEN, KM_SLEEP);
-
-		if (sas_wwn) {
-			(void) sprintf(addr, "w%016"PRIx64, sas_wwn);
-		} else {
-			(void) sprintf(addr, "p%x", phy);
-		}
 		ASSERT(ptgt->m_devhdl == devhdl);
 
 		if ((topo_node->flags == MPTSAS_TOPO_FLAG_RAID_ASSOCIATED) ||
@@ -6080,83 +6980,8 @@
 			 */
 			(void) mptsas_get_raid_info(mpt);
 		}
-		/*
-		 * Abort all outstanding command on the device
-		 */
-		rval = mptsas_do_scsi_reset(mpt, devhdl);
-		if (rval) {
-			NDBG20(("mptsas%d handle_topo_change to reset target "
-			    "before offline devhdl:%x, phymask:%x, rval:%x",
-			    mpt->m_instance, ptgt->m_devhdl,
-			    ptgt->m_addr.mta_phymask, rval));
-		}
-
-		mutex_exit(&mpt->m_mutex);
-
-		ndi_devi_enter(scsi_vhci_dip, &circ);
-		ndi_devi_enter(parent, &circ1);
-		rval = mptsas_offline_target(parent, addr);
-		ndi_devi_exit(parent, circ1);
-		ndi_devi_exit(scsi_vhci_dip, circ);
-		NDBG20(("mptsas%d handle_topo_change to offline devhdl:%x, "
-		    "phymask:%x, rval:%x", mpt->m_instance,
-		    ptgt->m_devhdl, ptgt->m_addr.mta_phymask, rval));
-
-		kmem_free(addr, SCSI_MAXNAMELEN);
-
-		/*
-		 * Clear parent's props for SMHBA support
-		 */
-		flags = topo_node->flags;
-		if (flags == MPTSAS_TOPO_FLAG_DIRECT_ATTACHED_DEVICE) {
-			bzero(attached_wwnstr, sizeof (attached_wwnstr));
-			if (ddi_prop_update_string(DDI_DEV_T_NONE, parent,
-			    SCSI_ADDR_PROP_ATTACHED_PORT, attached_wwnstr) !=
-			    DDI_PROP_SUCCESS) {
-				(void) ddi_prop_remove(DDI_DEV_T_NONE, parent,
-				    SCSI_ADDR_PROP_ATTACHED_PORT);
-				mptsas_log(mpt, CE_WARN, "mptsas attached port "
-				    "prop update failed");
-				break;
-			}
-			if (ddi_prop_update_int(DDI_DEV_T_NONE, parent,
-			    MPTSAS_NUM_PHYS, 0) !=
-			    DDI_PROP_SUCCESS) {
-				(void) ddi_prop_remove(DDI_DEV_T_NONE, parent,
-				    MPTSAS_NUM_PHYS);
-				mptsas_log(mpt, CE_WARN, "mptsas num phys "
-				    "prop update failed");
-				break;
-			}
-			if (ddi_prop_update_int(DDI_DEV_T_NONE, parent,
-			    MPTSAS_VIRTUAL_PORT, 1) !=
-			    DDI_PROP_SUCCESS) {
-				(void) ddi_prop_remove(DDI_DEV_T_NONE, parent,
-				    MPTSAS_VIRTUAL_PORT);
-				mptsas_log(mpt, CE_WARN, "mptsas virtual port "
-				    "prop update failed");
-				break;
-			}
-		}
 
-		mutex_enter(&mpt->m_mutex);
-		ptgt->m_led_status = 0;
-		(void) mptsas_flush_led_status(mpt, ptgt);
-		if (rval == DDI_SUCCESS) {
-			refhash_remove(mpt->m_targets, ptgt);
-			ptgt = NULL;
-		} else {
-			/*
-			 * clean DR_INTRANSITION flag to allow I/O down to
-			 * PHCI driver since failover finished.
-			 * Invalidate the devhdl
-			 */
-			ptgt->m_devhdl = MPTSAS_INVALID_DEVHDL;
-			ptgt->m_tgt_unconfigured = 0;
-			mutex_enter(&mpt->m_tx_waitq_mutex);
-			ptgt->m_dr_flag = MPTSAS_DR_INACTIVE;
-			mutex_exit(&mpt->m_tx_waitq_mutex);
-		}
+		mptsas_offline_target(mpt, ptgt, topo_node->flags, parent);
 
 		/*
 		 * Send SAS IO Unit Control to free the dev handle
@@ -6165,33 +6990,29 @@
 		    (flags == MPTSAS_TOPO_FLAG_EXPANDER_ATTACHED_DEVICE)) {
 			rval = mptsas_free_devhdl(mpt, devhdl);
 
-			NDBG20(("mptsas%d handle_topo_change to remove "
+			NDBG20(("mptsas3%d handle_topo_change to remove "
 			    "devhdl:%x, rval:%x", mpt->m_instance, devhdl,
 			    rval));
 		}
 
 		break;
 	}
-	case MPTSAS_TOPO_FLAG_REMOVE_HANDLE:
+	case MPTSAS_DR_EVENT_REMOVE_HANDLE:
 	{
 		devhdl = topo_node->devhdl;
+
 		/*
-		 * If this is the remove handle event, do a reset first.
+		 * Do a reset first.
 		 */
-		if (topo_node->event == MPTSAS_TOPO_FLAG_REMOVE_HANDLE) {
-			rval = mptsas_do_scsi_reset(mpt, devhdl);
-			if (rval) {
-				NDBG20(("mpt%d reset target before remove "
-				    "devhdl:%x, rval:%x", mpt->m_instance,
-				    devhdl, rval));
-			}
-		}
+		rval = mptsas_do_scsi_reset(mpt, devhdl);
+		NDBG20(("mpt%d reset target before remove "
+		    "devhdl:%x, rval:%x", mpt->m_instance, devhdl, rval));
 
 		/*
 		 * Send SAS IO Unit Control to free the dev handle
 		 */
 		rval = mptsas_free_devhdl(mpt, devhdl);
-		NDBG20(("mptsas%d handle_topo_change to remove "
+		NDBG20(("mptsas3%d handle_topo_change to remove "
 		    "devhdl:%x, rval:%x", mpt->m_instance, devhdl,
 		    rval));
 		break;
@@ -6284,7 +7105,7 @@
 		}
 
 		mutex_enter(&mpt->m_mutex);
-		NDBG20(("mptsas%d handle_topo_change to remove devhdl:%x, "
+		NDBG20(("mptsas3%d handle_topo_change to remove devhdl:%x, "
 		    "rval:%x", mpt->m_instance, psmp->m_devhdl, rval));
 		if (rval == DDI_SUCCESS) {
 			refhash_remove(mpt->m_smp_targets, psmp);
@@ -6320,7 +7141,8 @@
 	mpt = replyh_arg->mpt;
 
 	eventreply = (pMpi2EventNotificationReply_t)
-	    (mpt->m_reply_frame + (rfm - mpt->m_reply_frame_dma_addr));
+	    (mpt->m_reply_frame + (rfm -
+	    (mpt->m_reply_frame_dma_addr&0xfffffffful)));
 	event = ddi_get16(mpt->m_acc_reply_frame_hdl, &eventreply->Event);
 
 
@@ -6408,21 +7230,24 @@
 	ASSERT(mutex_owned(&mpt->m_mutex));
 
 	eventreply = (pMpi2EventNotificationReply_t)
-	    (mpt->m_reply_frame + (rfm - mpt->m_reply_frame_dma_addr));
+	    (mpt->m_reply_frame + (rfm -
+	    (mpt->m_reply_frame_dma_addr&0xfffffffful)));
 	event = ddi_get16(mpt->m_acc_reply_frame_hdl, &eventreply->Event);
 
 	if (iocstatus = ddi_get16(mpt->m_acc_reply_frame_hdl,
 	    &eventreply->IOCStatus)) {
 		if (iocstatus == MPI2_IOCSTATUS_FLAG_LOG_INFO_AVAILABLE) {
 			mptsas_log(mpt, CE_WARN,
-			    "!mptsas_handle_event_sync: IOCStatus=0x%x, "
-			    "IOCLogInfo=0x%x", iocstatus,
+			    "!mptsas_handle_event_sync: event 0x%x, "
+			    "IOCStatus=0x%x, "
+			    "IOCLogInfo=0x%x", event, iocstatus,
 			    ddi_get32(mpt->m_acc_reply_frame_hdl,
 			    &eventreply->IOCLogInfo));
 		} else {
 			mptsas_log(mpt, CE_WARN,
-			    "mptsas_handle_event_sync: IOCStatus=0x%x, "
-			    "IOCLogInfo=0x%x", iocstatus,
+			    "mptsas_handle_event_sync: event 0x%x, "
+			    "IOCStatus=0x%x, "
+			    "(IOCLogInfo=0x%x)", event, iocstatus,
 			    ddi_get32(mpt->m_acc_reply_frame_hdl,
 			    &eventreply->IOCLogInfo));
 		}
@@ -6557,7 +7382,7 @@
 			switch (reason_code) {
 			case MPI2_EVENT_SAS_TOPO_RC_TARG_ADDED:
 			{
-				NDBG20(("mptsas%d phy %d physical_port %d "
+				NDBG20(("mptsas3%d phy %d physical_port %d "
 				    "dev_handle %d added", mpt->m_instance, phy,
 				    physport, dev_handle));
 				link_rate = ddi_get8(mpt->m_acc_reply_frame_hdl,
@@ -6593,6 +7418,10 @@
 					(void) sprintf(curr, "is online at 6.0 "
 					    "Gbps");
 					break;
+				case MPI25_EVENT_SAS_TOPO_LR_RATE_12_0:
+					(void) sprintf(curr,
+					    "is online at 12.0 Gbps");
+					break;
 				default:
 					(void) sprintf(curr, "state is "
 					    "unknown");
@@ -6639,7 +7468,7 @@
 			}
 			case MPI2_EVENT_SAS_TOPO_RC_TARG_NOT_RESPONDING:
 			{
-				NDBG20(("mptsas%d phy %d physical_port %d "
+				NDBG20(("mptsas3%d phy %d physical_port %d "
 				    "dev_handle %d removed", mpt->m_instance,
 				    phy, physport, dev_handle));
 				/*
@@ -6670,7 +7499,7 @@
 				 * mean that the DevHandle is invalid.  The
 				 * controller will still have a valid DevHandle
 				 * that must be removed.  To do this, use the
-				 * MPTSAS_TOPO_FLAG_REMOVE_HANDLE event.
+				 * MPTSAS_DR_EVENT_REMOVE_HANDLE event.
 				 */
 				if (ptgt == NULL) {
 					topo_node = kmem_zalloc(
@@ -6679,7 +7508,7 @@
 					topo_node->mpt = mpt;
 					topo_node->un.phymask = 0;
 					topo_node->event =
-					    MPTSAS_TOPO_FLAG_REMOVE_HANDLE;
+					    MPTSAS_DR_EVENT_REMOVE_HANDLE;
 					topo_node->devhdl = dev_handle;
 					topo_node->flags = flags;
 					topo_node->object = NULL;
@@ -6695,16 +7524,12 @@
 
 				/*
 				 * Update DR flag immediately avoid I/O failure
-				 * before failover finish. Pay attention to the
-				 * mutex protect, we need grab m_tx_waitq_mutex
-				 * during set m_dr_flag because we won't add
-				 * the following command into waitq, instead,
+				 * before failover finish. We won't add
+				 * any following commands into waitq, instead,
 				 * we need return TRAN_BUSY in the tran_start
 				 * context.
 				 */
-				mutex_enter(&mpt->m_tx_waitq_mutex);
 				ptgt->m_dr_flag = MPTSAS_DR_INTRANSITION;
-				mutex_exit(&mpt->m_tx_waitq_mutex);
 
 				topo_node = kmem_zalloc(
 				    sizeof (mptsas_topo_change_list_t),
@@ -6796,6 +7621,18 @@
 					    SAS_PHY_ONLINE,
 					    &mpt->m_phy_info[i].smhba_info);
 					break;
+				case MPI25_EVENT_SAS_TOPO_LR_RATE_12_0:
+					(void) sprintf(curr, "is online at "
+					    "12.0 Gbps");
+					if ((expd_handle == 0) &&
+					    (enc_handle == 1)) {
+						mpt->m_port_chng = 1;
+					}
+					mptsas_smhba_log_sysevent(mpt,
+					    ESC_SAS_PHY_EVENT,
+					    SAS_PHY_ONLINE,
+					    &mpt->m_phy_info[i].smhba_info);
+					break;
 				default:
 					(void) sprintf(curr, "state is "
 					    "unknown");
@@ -6833,6 +7670,10 @@
 					(void) sprintf(prev, ", was online at "
 					    "6.0 Gbps");
 					break;
+				case MPI25_EVENT_SAS_TOPO_LR_RATE_12_0:
+					(void) sprintf(prev, ", was online at "
+					    "12.0 Gbps");
+					break;
 				default:
 				break;
 				}
@@ -6847,7 +7688,7 @@
 				    "removal");
 				break;
 			}
-			NDBG20(("mptsas%d phy %d DevHandle %x, %s%s%s\n",
+			NDBG20(("mptsas3%d phy %d DevHandle %x, %s%s%s\n",
 			    mpt->m_instance, phy, dev_handle, string, curr,
 			    prev));
 		}
@@ -6858,6 +7699,12 @@
 			if ((ddi_taskq_dispatch(mpt->m_dr_taskq,
 			    mptsas_handle_dr, (void *)topo_head,
 			    DDI_NOSLEEP)) != DDI_SUCCESS) {
+				while (topo_head != NULL) {
+					topo_node = topo_head;
+					topo_head = topo_head->next;
+					kmem_free(topo_node,
+					    sizeof (mptsas_topo_change_list_t));
+				}
 				mptsas_log(mpt, CE_NOTE, "mptsas start taskq "
 				    "for handle SAS DR event failed. \n");
 			}
@@ -6879,7 +7726,7 @@
 		num_entries = ddi_get8(mpt->m_acc_reply_frame_hdl,
 		    &irChangeList->NumElements);
 
-		NDBG20(("mptsas%d IR_CONFIGURATION_CHANGE_LIST event received",
+		NDBG20(("mptsas3%d IR_CONFIGURATION_CHANGE_LIST event received",
 		    mpt->m_instance));
 
 		for (i = 0; i < num_entries; i++) {
@@ -6935,9 +7782,7 @@
 				/*
 				 * Update DR flag immediately avoid I/O failure
 				 */
-				mutex_enter(&mpt->m_tx_waitq_mutex);
 				ptgt->m_dr_flag = MPTSAS_DR_INTRANSITION;
-				mutex_exit(&mpt->m_tx_waitq_mutex);
 
 				topo_node = kmem_zalloc(
 				    sizeof (mptsas_topo_change_list_t),
@@ -6970,9 +7815,7 @@
 				/*
 				 * Update DR flag immediately avoid I/O failure
 				 */
-				mutex_enter(&mpt->m_tx_waitq_mutex);
 				ptgt->m_dr_flag = MPTSAS_DR_INTRANSITION;
-				mutex_exit(&mpt->m_tx_waitq_mutex);
 
 				topo_node = kmem_zalloc(
 				    sizeof (mptsas_topo_change_list_t),
